﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Test_VPR___BlackJack
{
    public class Deck
    {
        private List<Karte> _karten;

        public List<Karte> Karten
        {
            get { return _karten; }
            set { _karten = value; }
        }

        private int _maxKarten = 52;

        public int MaxKarten
        {
            get { return _maxKarten; }
            set { _maxKarten = value; }
        }

        public Deck()
        {
            _karten = new List<Karte>();
        }

        public void FuelleDeck()
        {
            if (_karten.Count > 0)
            {
                _karten.Clear();
            }

            foreach (Symbole symbol in Enum.GetValues(typeof(Symbole)))
            {
                foreach (Werte wert in Enum.GetValues(typeof(Werte)))
                {
                    if (_karten.Count < MaxKarten)
                    {
                        _karten.Add(new Karte((int)wert, symbol.ToString()));
                    }
                }
            }
            Console.WriteLine($"Anzahl der Karten nach dem Füllen: {_karten.Count}");
        }

        public void Mischen()
        {
            Random rnd = new Random();
            int anzahl = _karten.Count;
            while (anzahl > 1)
            {
                anzahl--;
                int k = rnd.Next(anzahl + 1);
                Karte value = _karten[k];
                _karten[k] = _karten[anzahl];
                _karten[anzahl] = value;
            }
            Console.WriteLine("Deck wurde gemischt.");
        }

        public Karte KarteZiehen()
        {
            if (_karten.Count == 0)
            {
                Console.WriteLine("Das Deck ist leer.");
                return null;
            }

            Karte gezogeneKarte = _karten[0];
            _karten.RemoveAt(0);

            Console.WriteLine($"Gezogene Karte: {gezogeneKarte.Symbol}, Wert: {gezogeneKarte.Wert}");
            Console.WriteLine();

            return gezogeneKarte;
        }

        public int VerdeckteKarteZiehen(int punkte)
        {
            if (_karten.Count == 0)
            {
                Console.WriteLine("Das Deck ist leer.");
            }

            Karte gezogeneKarte = _karten[0];
            _karten.RemoveAt(0);

            punkte += gezogeneKarte.Wert;

            Console.WriteLine($"Gezogene Karte: Verdeckt");
            Console.WriteLine();

            return punkte;
        }

        
    }
}
