﻿using System;
using System.ComponentModel;
using System.Net.NetworkInformation;
using System.Runtime.InteropServices;
using System.Text;

namespace Test_VPR___BlackJack
{
    #region enums

    #region Spielzug
    public enum Spielzug
    {
        Hit = 1,
        Stand = 2,
        Double = 3,
        Split = 4
    }
    #endregion

    #region Spielstatus
    public enum Spielstatus
    {
        SpielerBust,
        DealerBust,
        SpielerBlackjack,
        DealerBlackjack,
        Unentschieden,
        SpielerVerloren,
        SpielerGewonnen,
        zweiteHandSpielerBust,
        zweiteHandSpielerBlackjack,
        zweiteHandUnentschieden,
        zweiteHandSpielerVerloren,
        zweiteHandSpielerGewonnen,
        Weiter
    }
    #endregion

    #region Spielergebnis
    public enum Spielergebnis
    {
        inMatch,
        Sieg,
        Unentschieden,
        Niederlage
    }
    #endregion

    #region SplitAnzahl
    public enum SplitAnzahl
    {
        keinSplit = 0,
        ersterSplit = 1,
    }
    #endregion

    #endregion

    internal class Program
    {
        static void Main(string[] args)
        {
            Console.OutputEncoding = Encoding.UTF8;
            Program program = new Program();
            program.ProgramStart();
        }

        #region ProgramStart

        public void ProgramStart()
        {
            #region Variablen
            bool weiterspielen = true;
            int konto = 1000;
            int wins = 0;
            int loses = 0;
            int ties = 0;
            int winstreak = 0;
            int losestreak = 0;
            int tiestreak = 0;
            int highscoreGeld = konto;
            int earnedGeld = 0;
            int highscoreBlackJacks = 0;
            int winstreaktemp = 0;
            int losestreaktemp = 0;
            int tiestreaktemp = 0;
            bool firstRoundOver;
            bool isStand;
            bool isWin;
            int punkteSpieler = 0;
            int punkteDealer = 0;
            int verdecktePunkte;
            int rundenAnzahl = 1;
            int einsatz;
            bool gameOver;
            Deck deck;
            Spielergebnis spielErgebnis;
            Spielstatus status;
            int zweiteHandPunkte = 0;
            int zweiteHandEinsatz = 0;
            SplitAnzahl splitAnzahl = SplitAnzahl.keinSplit;
            int aktSplitAnzahl = 0;
            string ausgabeSpielzugWahl;
            string ausgabeSpielzugWahl2Hand;
            bool istErsteHand = true;
            bool istZweiteHand = false;
            bool istTeilbar = false;
            bool gameOver2 = false;
            bool isStand2;
            #endregion


            while (weiterspielen && konto > 0)
            {
                #region Variablen
                punkteSpieler = 0;
                punkteDealer = 0;
                verdecktePunkte = 0;
                rundenAnzahl = 1;
                einsatz = 0;
                firstRoundOver = false;
                isStand = false;
                gameOver = false;
                isWin = false;
                deck = new Deck();
                spielErgebnis = Spielergebnis.inMatch;
                zweiteHandPunkte = 0;
                status = Spielstatus.Weiter;
                splitAnzahl = SplitAnzahl.keinSplit;
                aktSplitAnzahl = 0;
                ausgabeSpielzugWahl = null;
                ausgabeSpielzugWahl2Hand = null;
                istErsteHand = true;
                istZweiteHand = false;
                istTeilbar = false;
                gameOver2 = false;
                isStand2 = false;

                #endregion 

                (punkteSpieler, punkteDealer, verdecktePunkte, gameOver, firstRoundOver, isStand, weiterspielen, rundenAnzahl, konto, einsatz, wins, loses, winstreak, losestreak, highscoreGeld, earnedGeld, highscoreBlackJacks, isWin, spielErgebnis, status, zweiteHandPunkte, zweiteHandEinsatz, aktSplitAnzahl, splitAnzahl, istErsteHand, istZweiteHand, istTeilbar, gameOver2, isStand2)
                    = SpielStarten(punkteSpieler, punkteDealer, verdecktePunkte, rundenAnzahl, deck, gameOver, firstRoundOver, isStand, weiterspielen, konto, einsatz, wins, loses, winstreak, losestreak, highscoreGeld, earnedGeld, highscoreBlackJacks, isWin, spielErgebnis, status, zweiteHandPunkte, zweiteHandEinsatz, aktSplitAnzahl, splitAnzahl, ausgabeSpielzugWahl, ausgabeSpielzugWahl2Hand, istErsteHand, istZweiteHand, istTeilbar, gameOver2, isStand2);

                #region Spielergebnis Prüfen
                if (spielErgebnis == Spielergebnis.Sieg)
                {
                    winstreaktemp++;
                    wins++;

                    if (losestreak <= losestreaktemp)
                    {
                        losestreak = losestreaktemp;
                    }
                    losestreaktemp = 0;
                    tiestreaktemp = 0;
                }
                else if (spielErgebnis == Spielergebnis.Niederlage)
                {
                    losestreaktemp++;
                    loses++;


                    if (winstreak <= winstreaktemp)
                    {
                        winstreak = winstreaktemp;
                    }
                    winstreaktemp = 0;
                    tiestreaktemp = 0;
                }
                else
                {
                    tiestreaktemp++;
                    ties++;

                    if (tiestreak <= tiestreaktemp)
                    {
                        tiestreak = tiestreaktemp;
                    }
                    winstreaktemp = 0;
                    losestreaktemp = 0;
                }
            }
            #endregion

            //Methode ZeigeEndergebnisse aufrufen
            ZeigeEndergebnisse(konto, wins, loses, highscoreGeld, earnedGeld, highscoreBlackJacks, winstreak, losestreak, tiestreak, ties);

            //Methode Zeige Endstand aufrufen 
            ZeigeEndstand(punkteSpieler, punkteDealer, rundenAnzahl, zweiteHandPunkte, splitAnzahl, istTeilbar);
        }


        #endregion


        #region SpielStarten
        public (int, int, int, bool, bool, bool, bool, int, int, int, int, int, int, int, int, int, int, bool, Spielergebnis, Spielstatus, int, int, int, SplitAnzahl, bool, bool, bool, bool, bool)
            SpielStarten(int punkteSpieler, int punkteDealer, int verdecktePunkte, int rundenAnzahl, Deck deck, bool gameOver, bool firstRoundOver, bool isStand, bool weiterspielen, int konto, int einsatz, int wins, int loses, int winstreak, int losestreak, int highscoreGeld, int earnedGeld, int highscoreBlackJacks, bool isWin, Spielergebnis spielErgebnis, Spielstatus status, int zweiteHandPunkte, int zweiteHandEinsatz, int aktSplitAnzahl, SplitAnzahl splitAnzahl, string ausgabeSpielzugWahl, string ausgabeSpielzugWahl2Hand, bool istErsteHand, bool istZweiteHand, bool istTeilbar, bool gameOver2, bool isStand2)
        {

            //RundenStart Methode starten
            (punkteSpieler, punkteDealer, verdecktePunkte, rundenAnzahl, einsatz, istTeilbar) = RundenStart(punkteSpieler, punkteDealer, rundenAnzahl, deck, einsatz, konto, istTeilbar);

            //Spieltatus prüfen
            (konto, earnedGeld, highscoreGeld, highscoreBlackJacks, gameOver, spielErgebnis, isWin, gameOver2, isStand2)
                    = PruefeSpielstatus(status, punkteSpieler, punkteDealer, isStand, konto, einsatz, rundenAnzahl, gameOver, isWin, spielErgebnis, earnedGeld, highscoreGeld, highscoreBlackJacks, zweiteHandPunkte, aktSplitAnzahl, splitAnzahl, zweiteHandEinsatz,istErsteHand, istZweiteHand, istTeilbar, gameOver2, isStand2);


            //Solange das Spiel nicht beendet wurde Runden Methode aufrufen
            while (!gameOver && !gameOver)
            {
                ZeigeSpielstand(punkteSpieler, punkteDealer, rundenAnzahl, zweiteHandPunkte, splitAnzahl);

                //Runden Methode Starten
                (punkteSpieler, punkteDealer, gameOver, firstRoundOver, isStand, einsatz, zweiteHandPunkte, zweiteHandEinsatz, aktSplitAnzahl, splitAnzahl, gameOver2, isStand2) 
                    = Runde(punkteSpieler, punkteDealer, verdecktePunkte, rundenAnzahl, deck, gameOver, firstRoundOver, isStand, einsatz, konto, zweiteHandPunkte, zweiteHandEinsatz, aktSplitAnzahl, splitAnzahl, ausgabeSpielzugWahl, ausgabeSpielzugWahl2Hand, istErsteHand, istZweiteHand, istTeilbar, gameOver2, isStand2);

                //Spieltatus prüfen
                (konto, earnedGeld, highscoreGeld, highscoreBlackJacks, gameOver, spielErgebnis, isWin, gameOver2, isStand2)
                    = PruefeSpielstatus(status, punkteSpieler, punkteDealer, isStand, konto, einsatz, rundenAnzahl, gameOver, isWin, spielErgebnis, earnedGeld, highscoreGeld, highscoreBlackJacks, zweiteHandPunkte, aktSplitAnzahl, splitAnzahl, zweiteHandEinsatz,  istErsteHand, istZweiteHand, istTeilbar, gameOver2, isStand2);

                //Rundenzahl erhöhen
                if (!gameOver)
                {
                    rundenAnzahl++;
                }
            }


            Console.WriteLine("Das Spiel ist vorbei.");
            Console.WriteLine("-------------------------------------------------");
            if (konto <= 0)
            {
                weiterspielen = false;
            }

            #region Weiterspielen Abfrage
            bool isRichtig = true;

            Console.WriteLine("\nWeiterspielen? (Ja / Nein)");
            string ausgabe = Console.ReadLine()?.ToLower();
            if (ausgabe == "Ja" || ausgabe == "ja")
            {
                weiterspielen = true;
            }
            else if (ausgabe == "Nein" || ausgabe == "nein")
            {
                weiterspielen = false;
                isRichtig = true;
            }
            else
            {
                Console.WriteLine("Falsche Eingabe. Bitte überprüfe deine Eingabe!");
                isRichtig = false;
            }
            while (!isRichtig)
            {
                Console.WriteLine("\nWeiterspielen? (Ja / Nein)");
                ausgabe = Console.ReadLine()?.ToLower();
                if (ausgabe == "Ja" || ausgabe == "ja")
                {
                    weiterspielen = true;
                    isRichtig = true;
                    break;
                }
                else if (ausgabe == "Nein" || ausgabe == "nein")
                {
                    weiterspielen = false;
                    isRichtig = true;
                    break;
                }
                else
                {
                    Console.WriteLine("Falsche Eingabe. Bitte überprüfe deine Eingabe!");
                    isRichtig = false;
                }
            }
            #endregion

            return (punkteSpieler, punkteDealer, verdecktePunkte, gameOver, firstRoundOver, isStand, weiterspielen, rundenAnzahl, konto, einsatz, wins, loses, winstreak, losestreak, highscoreGeld, earnedGeld, highscoreBlackJacks, isWin, spielErgebnis, status, zweiteHandPunkte, zweiteHandEinsatz, aktSplitAnzahl, splitAnzahl, istErsteHand, istZweiteHand, istTeilbar, gameOver2, isStand2);
        }

        #endregion


        #region Runden


        #region RundenStart

        public (int, int, int, int, int, bool)
            RundenStart(int punkteSpieler, int punkteDealer, int rundenAnzahl, Deck deck, int einsatz, int konto, bool istTeilbar)
        {
            int verdecktePunkte = 0;
            Console.WriteLine("-------------------------------------------------");
            Console.WriteLine($"Das Spiel beginnt!");
            Console.WriteLine($"Aktueller Kontostand: {konto}");
            bool gültigeEingabe = false;

            while (!gültigeEingabe)
            {
                Console.Write("\nBitte setzte deinen Einsatz: ");
                string eingabe = Console.ReadLine();

                if (int.TryParse(eingabe, out einsatz) && einsatz <= konto && !(einsatz < 0))
                {
                    gültigeEingabe = true;
                }
                else
                {
                    Console.WriteLine("Bitte gib einen Einsatz im Wertebereich deines Kontos an.");
                }
            }
            Console.WriteLine($"Dein Einsatz beträgt: {einsatz}");
            Console.WriteLine($"\nRunde {rundenAnzahl} startet");
            Console.WriteLine("-------------------------------------------------");

            deck.FuelleDeck();
            Console.WriteLine("Die Karten werden gemischt...");
            deck.Mischen();

            Console.WriteLine("Der Dealer teilt die Karten aus.");
            Karte dealerKarte2 = deck.KarteZiehen();
            punkteDealer += dealerKarte2.Wert;
            verdecktePunkte = deck.VerdeckteKarteZiehen(verdecktePunkte);
            Karte spielerKarte1 = deck.KarteZiehen();
            Karte spielerKarte2 = deck.KarteZiehen();
            punkteSpieler += spielerKarte1.Wert;
            punkteSpieler += spielerKarte2.Wert;


            if(spielerKarte1.Wert == spielerKarte2.Wert)
            {
                istTeilbar = true;
            }

            return (punkteSpieler, punkteDealer, verdecktePunkte, rundenAnzahl, einsatz, istTeilbar);
        }

        #endregion


        #region Runde

        public (int, int, bool, bool, bool,int, int,int, int, SplitAnzahl, bool, bool)
            Runde(int punkteSpieler, int punkteDealer, int verdecktePunkte, int rundenAnzahl, Deck deck, bool gameOver, bool firstRoundOver, bool isStand, int einsatz, int konto, int zweiteHandPunkte, int zweiteHandEinsatz, int aktSplitAnzahl, SplitAnzahl splitAnzahl, string ausgabeSpielzugWahl, string ausgabeSpielzugWahl2Hand, bool istErsteHand, bool istZweiteHand, bool istTeilbar, bool gameOver2, bool isStand2)
        {
            if (!gameOver)
            {
                switch (splitAnzahl)
                {
                    case SplitAnzahl.keinSplit:
                        Console.WriteLine("Wähle deinen Zug:");
                        Console.WriteLine("1. Hit");
                        Console.WriteLine("2. Stand");
                        Console.WriteLine("3. Double Down");
                        Console.WriteLine("4. Split");
                        Console.Write("\nDeine Wahl: ");
                        ausgabeSpielzugWahl = Console.ReadLine();

                        (punkteSpieler, punkteDealer, gameOver, firstRoundOver, isStand, einsatz, zweiteHandPunkte, zweiteHandEinsatz, aktSplitAnzahl, splitAnzahl, gameOver2, isStand2) =
                            SpielzugAuswahl(punkteSpieler, punkteDealer, verdecktePunkte, rundenAnzahl, deck, gameOver, firstRoundOver, isStand, einsatz, konto, zweiteHandPunkte, zweiteHandEinsatz, aktSplitAnzahl, splitAnzahl, ausgabeSpielzugWahl, ausgabeSpielzugWahl2Hand, istErsteHand, istZweiteHand, istTeilbar, gameOver2, isStand2);
                        
                        break;
                    case SplitAnzahl.ersterSplit:
                        istErsteHand = true;
                        Console.WriteLine("Wähle deinen Zug für deine 1.Hand:");
                        Console.WriteLine("1. Hit");
                        Console.WriteLine("2. Stand");
                        Console.WriteLine("3. Double Down");
                        Console.WriteLine("4. Split");
                        Console.Write("\nDeine Wahl: ");
                        ausgabeSpielzugWahl = Console.ReadLine();

                        (punkteSpieler, punkteDealer, gameOver, firstRoundOver, isStand, einsatz, zweiteHandPunkte, zweiteHandEinsatz, aktSplitAnzahl, splitAnzahl, gameOver2, isStand2) =
                            SpielzugAuswahl(punkteSpieler, punkteDealer, verdecktePunkte, rundenAnzahl, deck, gameOver, firstRoundOver, isStand, einsatz, konto, zweiteHandPunkte, zweiteHandEinsatz, aktSplitAnzahl, splitAnzahl, ausgabeSpielzugWahl, ausgabeSpielzugWahl2Hand, istErsteHand, istZweiteHand, istTeilbar, gameOver2, isStand2);

                        ausgabeSpielzugWahl = null;
                        istErsteHand = false;
                        istZweiteHand = true;

                        Console.WriteLine("Wähle deinen Zug für deine 2.Hand:");
                        Console.WriteLine("1. Hit");
                        Console.WriteLine("2. Stand");
                        Console.WriteLine("3. Double Down");
                        Console.WriteLine("4. Split");
                        Console.Write("\nDeine Wahl: ");
                        ausgabeSpielzugWahl2Hand = Console.ReadLine();

                        (punkteSpieler, punkteDealer, gameOver, firstRoundOver, isStand, einsatz, zweiteHandPunkte, zweiteHandEinsatz, aktSplitAnzahl, splitAnzahl, gameOver2, isStand2) =
                            SpielzugAuswahl(punkteSpieler, punkteDealer, verdecktePunkte, rundenAnzahl, deck, gameOver, firstRoundOver, isStand, einsatz, konto, zweiteHandPunkte, zweiteHandEinsatz, aktSplitAnzahl, splitAnzahl, ausgabeSpielzugWahl, ausgabeSpielzugWahl2Hand, istErsteHand, istZweiteHand, istTeilbar, gameOver2, isStand2);

                        ausgabeSpielzugWahl2Hand = null;
                        istZweiteHand = false;
                        break;         
                }

                //Abfrage für die Ersterunde
                if (!firstRoundOver)
                {
                    punkteDealer += verdecktePunkte;
                    Console.WriteLine($"Die verdeckte Karte des Dealers wird aufgedeckt: {verdecktePunkte}");
                    Console.WriteLine($"Dealer: {punkteDealer}");
                    Console.WriteLine();
                    firstRoundOver = true;
                }

                //Dealer zieht Karte wenn Dealerpunkte <17 und der Spieler Stand auswählt
                if (isStand || gameOver)
                {
                    while (punkteDealer < 17)
                    {
                        Karte dealerKarte = deck.KarteZiehen();
                        punkteDealer += dealerKarte.Wert;
                    }
                }
            }

            return (punkteSpieler, punkteDealer, gameOver, firstRoundOver, isStand, einsatz, zweiteHandPunkte, zweiteHandEinsatz, aktSplitAnzahl, splitAnzahl, gameOver2, isStand2);
        }
        #endregion


        #endregion


        #region SpielzugAuswahl
        public (int, int, bool, bool, bool, int, int,int, int, SplitAnzahl, bool, bool) SpielzugAuswahl(int punkteSpieler, int punkteDealer, int verdecktePunkte, int rundenAnzahl, Deck deck, bool gameOver, bool firstRoundOver, bool isStand, int einsatz, int konto, int zweiteHandPunkte, int zweiteHandEinsatz, int aktSplitAnzahl, SplitAnzahl splitAnzahl, string ausgabeSpielzugWahl, string ausgabeSpielzugWahl2Hand, bool istErsteHand, bool istZweiteHand, bool istTeilbar, bool gameOver2, bool isStand2)
        {
            Spielzug spielzug;
            //Spieler wählt Spielzug aus
            if (Enum.TryParse<Spielzug>(ausgabeSpielzugWahl, out spielzug) || Enum.TryParse<Spielzug>(ausgabeSpielzugWahl2Hand, out spielzug))
            {
                switch (spielzug)
                {
                    case Spielzug.Hit:
                        (punkteSpieler, zweiteHandPunkte) = Hit(punkteSpieler, zweiteHandPunkte, deck, splitAnzahl, istErsteHand, istZweiteHand);
                        break;
                    case Spielzug.Stand:
                        (isStand, isStand2) = Stand(isStand, splitAnzahl, istErsteHand, istZweiteHand, isStand2);
                        break;
                    case Spielzug.Double:
                        (einsatz, isStand, gameOver, punkteSpieler, zweiteHandPunkte, gameOver2, isStand2) = DoubleDown(einsatz, isStand, gameOver, punkteSpieler, deck, konto, zweiteHandPunkte, splitAnzahl, istErsteHand, istZweiteHand, gameOver2, isStand2);
                        break;
                    case Spielzug.Split:
                        if (!firstRoundOver || KannSplitten(punkteSpieler, zweiteHandPunkte) && istTeilbar)
                        {
                            (punkteSpieler, einsatz, zweiteHandPunkte, zweiteHandEinsatz, aktSplitAnzahl, splitAnzahl) = Split(punkteSpieler, deck, einsatz, konto, zweiteHandPunkte, zweiteHandEinsatz, aktSplitAnzahl, splitAnzahl, istTeilbar);
                        }
                        else
                        {
                            Console.WriteLine("Du kannst nach der ersten Runde nicht mehr Splitten");
                        }
                        break;
                    default:
                        Console.WriteLine("Ungültige Auswahl. Bitte erneut versuchen.");
                        break;
                }
            }
            else
            {
                Console.WriteLine("Ungültige Eingabe. Bitte gib eine Zahl von 1 bis 4 ein.");
            }
            return (punkteSpieler, punkteDealer, gameOver, firstRoundOver, isStand, einsatz, zweiteHandPunkte, zweiteHandEinsatz, aktSplitAnzahl, splitAnzahl, gameOver2, isStand2);
        }
        #endregion


        #region Spielzüge


        #region Hit

        public (int,int) Hit(int punkteSpieler, int zweiteHandPunkte, Deck deck, SplitAnzahl splitAnzahl, bool istErsteHand, bool istZweiteHand)
        {
            Karte spielerKarte;
            switch (splitAnzahl)
            {
                case SplitAnzahl.keinSplit:
                    Console.WriteLine("Du wählst Hit.");
                    spielerKarte = deck.KarteZiehen();
                    punkteSpieler += spielerKarte.Wert;
                    break;
                case SplitAnzahl.ersterSplit:
                    if (istErsteHand)
                    {
                        Console.WriteLine("Du wählst mit deiner 1.Hand Hit.");
                        spielerKarte = deck.KarteZiehen();
                        punkteSpieler += spielerKarte.Wert;
                    }
                    else if (istZweiteHand)
                    {
                        Console.WriteLine("Du wählst mit deiner 2.Hand Hit.");
                        spielerKarte = deck.KarteZiehen();
                        zweiteHandPunkte += spielerKarte.Wert;
                    }
                    break;
            }
            return (punkteSpieler, zweiteHandPunkte);
        }
        #endregion


        #region Stand

        public (bool, bool) Stand(bool isStand, SplitAnzahl splitAnzahl, bool istErsteHand, bool istZweiteHand, bool isStand2)
        {
            switch (splitAnzahl)
            {
                case SplitAnzahl.keinSplit:
                    Console.WriteLine("Du wählst Stand.");
                    isStand = true;
                    break;
                case SplitAnzahl.ersterSplit:
                    if (istErsteHand)
                    {
                        Console.WriteLine("Du wählst mit deiner 1.Hand Stand.");
                        isStand = true;
                    }
                    else if (istZweiteHand)
                    {
                        Console.WriteLine("Du wählst mit deiner 2.Hand Stand.");
                        isStand2 = true;
                    }
                    break;
            }
            
            return (isStand, isStand2);
        }

        #endregion


        #region DoubleDown
        public (int , bool, bool, int, int, bool, bool) DoubleDown(int einsatz, bool isStand, bool gameOver, int punkteSpieler, Deck deck, int konto, int zweiteHandPunkte, SplitAnzahl splitAnzahl, bool istErsteHand, bool istZweiteHand, bool gameOver2, bool isStand2)
        {
            Karte spielerKarte;
            if(konto >= (einsatz * 2))
            {
                switch (splitAnzahl)
                {
                    case SplitAnzahl.keinSplit:
                        Console.WriteLine("Du wählst Double Down.");
                        Console.Write($"Dein Einsatz {einsatz} ");
                        einsatz *= 2;
                        Console.WriteLine($"wurde auf {einsatz}€ geändert.");
                        spielerKarte = deck.KarteZiehen();
                        punkteSpieler += spielerKarte.Wert;
                        Console.WriteLine($"Du: {punkteSpieler}");
                        isStand = true;
                        gameOver = true;
                        break;
                    case SplitAnzahl.ersterSplit:
                        if (istErsteHand)
                        {
                            Console.WriteLine("Du wählst mit deiner 1.Hand Double Down.");
                            Console.Write($"Dein Einsatz {einsatz} ");
                            einsatz *= 2;
                            Console.WriteLine($"wurde auf {einsatz}€ geändert.");
                            spielerKarte = deck.KarteZiehen();
                            punkteSpieler += spielerKarte.Wert;
                            Console.WriteLine($"Du: {punkteSpieler}");
                            isStand = true;
                            gameOver = true;
                        }
                        else if (istZweiteHand)
                        {
                            Console.WriteLine("Du wählst mit deiner 2.Hand Double Down.");
                            Console.Write($"Dein Einsatz {einsatz} ");
                            einsatz *= 2;
                            Console.WriteLine($"wurde auf {einsatz}€ geändert.");
                            spielerKarte = deck.KarteZiehen();
                            zweiteHandPunkte += spielerKarte.Wert;
                            Console.WriteLine($"Du: {zweiteHandPunkte}");
                            isStand2 = true;
                            gameOver2 = true;
                        }
                        break;
                }
            }
            else
            {
                Console.WriteLine($"Du brauchst {einsatz * 2}€ hast aber nur, {konto}€ auf den Konto!");
            }
            
            return (einsatz, isStand, gameOver, punkteSpieler, zweiteHandPunkte, gameOver2, isStand);
        }

        #endregion


        #region Split
        public (int, int, int, int, int, SplitAnzahl) 
            Split(int punkteSpieler, Deck deck, int einsatz, int konto, int zweiteHandPunkte, int zweiteHandEinsatz, int aktSplitAnzahl, SplitAnzahl splitAnzahl, bool istTeilbar)
        {
            Karte spielerKarte;
            Karte spielerKarte2;

            if (KannSplitten(punkteSpieler, zweiteHandPunkte) && istTeilbar)
            {
                aktSplitAnzahl++;
                if (aktSplitAnzahl == 0)
                {
                    splitAnzahl = SplitAnzahl.keinSplit;
                }
                else if(aktSplitAnzahl == 1)
                {
                    splitAnzahl = SplitAnzahl.ersterSplit;
                }
                else if (aktSplitAnzahl > 3)
                {
                    Console.WriteLine("Du kannst nur 4 Hände maximal halten");
                }

                switch (splitAnzahl)
                {
                    case SplitAnzahl.ersterSplit:
                        if (punkteSpieler % 2 == 0 && istTeilbar)
                        {
                            punkteSpieler /= 2;
                            zweiteHandPunkte = punkteSpieler;
                        }
                        else
                        {
                            Console.WriteLine("Der Split ist nicht möglich, da die Punkte nicht identisch sind.");
                            istTeilbar = false;
                            break;
                        }
                        aktSplitAnzahl++;
                        Console.WriteLine("Du wählst Split.");
                        Console.WriteLine($"Du spielst nun mit einer zweiten Hand und hast den Wert der beiden Karten aufgeteilt.");
                        Console.WriteLine($"DU 1.Hand: {punkteSpieler}");
                        Console.WriteLine($"DU 2.Hand: {zweiteHandPunkte}");
                        zweiteHandEinsatz = einsatz;
                        Console.WriteLine($"Der Einsatz für die zweite Hand beträgt auch {zweiteHandEinsatz}€.");
                        spielerKarte = deck.KarteZiehen();
                        punkteSpieler += spielerKarte.Wert;
                        spielerKarte2 = deck.KarteZiehen();
                        zweiteHandPunkte += spielerKarte2.Wert;
                        Console.WriteLine($"DU 1.Hand: {punkteSpieler}");
                        Console.WriteLine($"DU 2.Hand: {zweiteHandPunkte}");
                        break;
                    default:
                        Console.WriteLine("Fehler beim Splittyp");
                        break;
                }
            }
            else if(!KannSplitten(punkteSpieler, zweiteHandPunkte))
            {
                Console.WriteLine("Kartenwerte treffen nicht überein");
            }
            else if (konto < (einsatz * 2))
            {
                Console.WriteLine($"Du brauchst {einsatz * 2}€ hast aber nur, {konto}€ auf den Konto!");
            }
            return (punkteSpieler, einsatz, zweiteHandPunkte, zweiteHandEinsatz, aktSplitAnzahl, splitAnzahl);
        }

        public bool KannSplitten(int punkteSpieler, int zweiteHandPunkte)
        {
            return punkteSpieler % 2 == 0 || zweiteHandPunkte % 2 == 0;
        }
        #endregion


        #endregion


        #region Pruefen


        #region SpielstatusUnterscheidung
        public Spielstatus SpielstatusUnterscheidung(int punkteSpieler, int punkteDealer, bool isStand, Spielstatus status, int zweiteHandPunkte, SplitAnzahl splitAnzahl, bool isStand2)
        {
            //Methode returnt den aktuellen Spielstatus
            int blackjack = 21;

            //Fallunterscheidung bei Spieler

            //Erste Hand
            if (punkteSpieler > blackjack)
            {
                return status = Spielstatus.SpielerBust;
            }
            else if (punkteSpieler == blackjack && punkteSpieler != punkteDealer)
            {
                return status = Spielstatus.SpielerBlackjack;
            }
            else if (isStand && punkteSpieler == punkteDealer)
            {
                return status = Spielstatus.Unentschieden;
            }
            else if (isStand && punkteSpieler < punkteDealer && punkteDealer < blackjack)
            {
                return status = Spielstatus.SpielerVerloren;
            }
            else if (isStand && punkteSpieler > punkteDealer && punkteSpieler < blackjack)
            {
                return status = Spielstatus.SpielerGewonnen;
            }
            else if (isStand && punkteDealer > blackjack && punkteDealer > punkteSpieler)
            {
                return status = Spielstatus.DealerBust;
            }


            //Zweite Hand
            if (zweiteHandPunkte > blackjack)
            {
                return status = Spielstatus.zweiteHandSpielerBust;
            }
            else if (zweiteHandPunkte == blackjack && zweiteHandPunkte != punkteDealer)
            {
                return status = Spielstatus.zweiteHandSpielerBlackjack;
            }
            else if (isStand2 && zweiteHandPunkte == punkteDealer)
            {
                return status = Spielstatus.zweiteHandUnentschieden;
            }
            else if (isStand2 && zweiteHandPunkte < punkteDealer && punkteDealer < blackjack)
            {
                return status = Spielstatus.zweiteHandSpielerVerloren;
            }
            else if (isStand2 && zweiteHandPunkte > punkteDealer && punkteSpieler < blackjack)
            {
                return status = Spielstatus.zweiteHandSpielerGewonnen;
            }
            else if (isStand2 && punkteDealer > blackjack && punkteDealer > zweiteHandPunkte)
            {
                return status = Spielstatus.DealerBust;
            }

            //Dealer
            if (punkteDealer > blackjack)
            {
                return status = Spielstatus.DealerBust;
            }
            else if (punkteDealer == blackjack && punkteDealer != punkteSpieler && punkteDealer != zweiteHandPunkte)
            {
                return status = Spielstatus.DealerBlackjack;
            }
            

            return Spielstatus.Weiter;
        }
        #endregion


        #region PruefeSpielstatus
        public (int, int, int, int, bool, Spielergebnis, bool, bool, bool) PruefeSpielstatus(Spielstatus status, int punkteSpieler, int punkteDealer, bool isStand, int konto, int einsatz, int rundenAnzahl, bool gameOver, bool isWin, Spielergebnis spielErgebnis, int earnedGeld, int highscoreGeld, int highscoreBlackJacks, int zweiteHandPunkte, int aktSplitAnzahl, SplitAnzahl splitAnzahl, int zweiteHandEinsatz, bool istErsteHand, bool istZweiteHand, bool istTeilbar, bool gameOver2, bool isStand2)
        {
            //Aufruf der SpielstatusUnterscheiungs Methode
            status = SpielstatusUnterscheidung(punkteSpieler, punkteDealer, isStand, status, zweiteHandPunkte, splitAnzahl, isStand2);

            //Fallunterscheidung des Splitstatus
            switch (splitAnzahl)
            {
                //Noch nicht gesplittet
                case SplitAnzahl.keinSplit:
                    switch (status)
                    {
                        case Spielstatus.SpielerBust:
                            Console.WriteLine("-------------------------------------------------");
                            Console.WriteLine("Bust! Du hast verloren.");
                            ZeigeEndstand(punkteSpieler, punkteDealer, rundenAnzahl, zweiteHandPunkte, splitAnzahl, istTeilbar);
                            konto -= einsatz;
                            gameOver = true;
                            isWin = false;
                            spielErgebnis = Spielergebnis.Niederlage;
                            break;
                        case Spielstatus.DealerBust:
                            Console.WriteLine("-------------------------------------------------");
                            Console.WriteLine("Dealer Bust! Du hast gewonnen.");
                            ZeigeEndstand(punkteSpieler, punkteDealer, rundenAnzahl, zweiteHandPunkte, splitAnzahl, istTeilbar);
                            konto += einsatz;
                            earnedGeld += einsatz;
                            if (konto > highscoreGeld)
                            {
                                highscoreGeld = konto;
                            }
                            gameOver = true;
                            isWin = true;
                            spielErgebnis = Spielergebnis.Sieg;
                            break;
                        case Spielstatus.SpielerBlackjack:
                            Console.WriteLine("-------------------------------------------------");
                            Console.WriteLine("Blackjack! Du hast gewonnen.");
                            ZeigeEndstand(punkteSpieler, punkteDealer, rundenAnzahl, zweiteHandPunkte, splitAnzahl, istTeilbar);
                            highscoreBlackJacks++;
                            konto += einsatz;
                            earnedGeld += einsatz;
                            if (konto > highscoreGeld)
                            {
                                highscoreGeld = konto;
                            }
                            gameOver = true;
                            isWin = true;
                            spielErgebnis = Spielergebnis.Sieg;
                            break;
                        case Spielstatus.DealerBlackjack:
                            Console.WriteLine("-------------------------------------------------");
                            Console.WriteLine("Dealer Blackjack! Du hast verloren.");
                            ZeigeEndstand(punkteSpieler, punkteDealer, rundenAnzahl, zweiteHandPunkte, splitAnzahl, istTeilbar);
                            konto -= einsatz;
                            gameOver = true;
                            isWin = false;
                            spielErgebnis = Spielergebnis.Niederlage;
                            break;

                        case Spielstatus.Unentschieden:
                            Console.WriteLine("-------------------------------------------------");
                            Console.WriteLine("Unentschieden!");
                            ZeigeEndstand(punkteSpieler, punkteDealer, rundenAnzahl, zweiteHandPunkte, splitAnzahl, istTeilbar);
                            gameOver = true;
                            spielErgebnis = Spielergebnis.Unentschieden;
                            break;

                        case Spielstatus.SpielerVerloren:
                            Console.WriteLine("-------------------------------------------------");
                            Console.WriteLine("Du hast verloren.");
                            ZeigeEndstand(punkteSpieler, punkteDealer, rundenAnzahl, zweiteHandPunkte, splitAnzahl, istTeilbar);
                            konto -= einsatz;
                            gameOver = true;
                            spielErgebnis = Spielergebnis.Niederlage;
                            break;

                        case Spielstatus.SpielerGewonnen:
                            Console.WriteLine("-------------------------------------------------");
                            Console.WriteLine("Du hast gewonnen.");
                            ZeigeEndstand(punkteSpieler, punkteDealer, rundenAnzahl, zweiteHandPunkte, splitAnzahl, istTeilbar);
                            konto += einsatz;
                            earnedGeld += einsatz;
                            if (konto > highscoreGeld)
                            {
                                highscoreGeld = konto;
                            }
                            gameOver = true;
                            spielErgebnis = Spielergebnis.Sieg;
                            break;

                        case Spielstatus.Weiter:
                            break;
                    }
                    break;
                //Wurde gesplittet
                case SplitAnzahl.ersterSplit:
                    //Unterscheidung für 1. Hand
                    if (istErsteHand)
                    {
                        switch (status)
                        {
                            case Spielstatus.SpielerBust:
                                Console.WriteLine("-------------------------------------------------");
                                Console.WriteLine("Bust! Du hast mit deiner 1.Hand verloren.");
                                ZeigeEndstand(punkteSpieler, punkteDealer, rundenAnzahl, zweiteHandPunkte, splitAnzahl, istTeilbar);
                                konto -= einsatz;
                                gameOver = true;
                                isWin = false;
                                spielErgebnis = Spielergebnis.Niederlage;
                                break;
                            case Spielstatus.DealerBust:
                                Console.WriteLine("-------------------------------------------------");
                                Console.WriteLine("Dealer Bust! Du hast mit deiner 1.Hand gewonnen.");
                                ZeigeEndstand(punkteSpieler, punkteDealer, rundenAnzahl, zweiteHandPunkte, splitAnzahl, istTeilbar);
                                konto += einsatz;
                                earnedGeld += einsatz;
                                if (konto > highscoreGeld)
                                {
                                    highscoreGeld = konto;
                                }
                                gameOver = true;
                                isWin = true;
                                spielErgebnis = Spielergebnis.Sieg;
                                break;
                            case Spielstatus.SpielerBlackjack:
                                Console.WriteLine("-------------------------------------------------");
                                Console.WriteLine("Blackjack! Du hast mit deiner 1.Hand gewonnen.");
                                ZeigeEndstand(punkteSpieler, punkteDealer, rundenAnzahl, zweiteHandPunkte, splitAnzahl, istTeilbar);
                                highscoreBlackJacks++;
                                konto += einsatz;
                                earnedGeld += einsatz;
                                if (konto > highscoreGeld)
                                {
                                    highscoreGeld = konto;
                                }
                                gameOver = true;
                                isWin = true;
                                spielErgebnis = Spielergebnis.Sieg;
                                break;
                            case Spielstatus.DealerBlackjack:
                                Console.WriteLine("-------------------------------------------------");
                                Console.WriteLine("Dealer Blackjack! Du hast mit deiner 1.Hand verloren.");
                                ZeigeEndstand(punkteSpieler, punkteDealer, rundenAnzahl, zweiteHandPunkte, splitAnzahl, istTeilbar);
                                konto -= einsatz;
                                gameOver = true;
                                isWin = false;
                                spielErgebnis = Spielergebnis.Niederlage;
                                break;

                            case Spielstatus.Unentschieden:
                                Console.WriteLine("-------------------------------------------------");
                                Console.WriteLine("Unentschieden mit deiner 1.Hand!");
                                ZeigeEndstand(punkteSpieler, punkteDealer, rundenAnzahl, zweiteHandPunkte, splitAnzahl, istTeilbar);
                                gameOver = true;
                                spielErgebnis = Spielergebnis.Unentschieden;
                                break;
                            case Spielstatus.SpielerVerloren:
                                Console.WriteLine("-------------------------------------------------");
                                Console.WriteLine("Du hast mit deiner 1.Hand verloren.");
                                ZeigeEndstand(punkteSpieler, punkteDealer, rundenAnzahl, zweiteHandPunkte, splitAnzahl, istTeilbar);
                                konto -= einsatz;
                                gameOver = true;
                                spielErgebnis = Spielergebnis.Niederlage;
                                break;
                            case Spielstatus.SpielerGewonnen:
                                Console.WriteLine("-------------------------------------------------");
                                Console.WriteLine("Du hast mit deiner 1.Hand gewonnen.");
                                ZeigeEndstand(punkteSpieler, punkteDealer, rundenAnzahl, zweiteHandPunkte, splitAnzahl, istTeilbar);
                                konto += einsatz;
                                earnedGeld += einsatz;
                                if (konto > highscoreGeld)
                                {
                                    highscoreGeld = konto;
                                }
                                gameOver = true;
                                spielErgebnis = Spielergebnis.Sieg;
                                break;
                            case Spielstatus.Weiter:
                                break;
                        }
                    }
                    //Unterscheidung für 2. Hand
                    if (istZweiteHand)
                    {
                        switch (status)
                        {
                            case Spielstatus.zweiteHandSpielerBust:
                                Console.WriteLine("-------------------------------------------------");
                                Console.WriteLine("Bust! Du hast mit deiner 2.Hand verloren.");
                                ZeigeEndstand(punkteSpieler, punkteDealer, rundenAnzahl, zweiteHandPunkte, splitAnzahl, istTeilbar);
                                konto -= zweiteHandEinsatz;
                                gameOver2 = true;
                                isWin = false;
                                spielErgebnis = Spielergebnis.Niederlage;
                                break;
                            case Spielstatus.zweiteHandSpielerBlackjack:
                                Console.WriteLine("-------------------------------------------------");
                                Console.WriteLine("Blackjack! Du hast mit deiner 2.Hand gewonnen.");
                                ZeigeEndstand(punkteSpieler, punkteDealer, rundenAnzahl, zweiteHandPunkte, splitAnzahl, istTeilbar);
                                highscoreBlackJacks++;
                                konto += zweiteHandEinsatz;
                                earnedGeld += zweiteHandEinsatz;
                                if (konto > highscoreGeld)
                                {
                                    highscoreGeld = konto;
                                }
                                gameOver2 = true;
                                isWin = true;
                                spielErgebnis = Spielergebnis.Sieg;
                                break;
                            case Spielstatus.zweiteHandUnentschieden:
                                Console.WriteLine("-------------------------------------------------");
                                Console.WriteLine("Unentschieden mit deiner 2.Hand!");
                                ZeigeEndstand(punkteSpieler, punkteDealer, rundenAnzahl, zweiteHandPunkte, splitAnzahl, istTeilbar);
                                gameOver2 = true;
                                spielErgebnis = Spielergebnis.Unentschieden;
                                break;
                            case Spielstatus.zweiteHandSpielerVerloren:
                                Console.WriteLine("-------------------------------------------------");
                                Console.WriteLine("Du hast mit deiner 2.Hand verloren.");
                                ZeigeEndstand(punkteSpieler, punkteDealer, rundenAnzahl, zweiteHandPunkte, splitAnzahl, istTeilbar);
                                konto -= zweiteHandEinsatz;
                                gameOver2 = true;
                                spielErgebnis = Spielergebnis.Niederlage;
                                break;
                            case Spielstatus.zweiteHandSpielerGewonnen:
                                Console.WriteLine("-------------------------------------------------");
                                Console.WriteLine("Du hast mit deiner 2.Hand gewonnen.");
                                ZeigeEndstand(punkteSpieler, punkteDealer, rundenAnzahl, zweiteHandPunkte, splitAnzahl, istTeilbar);
                                konto += zweiteHandEinsatz;
                                earnedGeld += zweiteHandEinsatz;
                                if (konto > highscoreGeld)
                                {
                                    highscoreGeld = konto;
                                }
                                gameOver2 = true;
                                spielErgebnis = Spielergebnis.Sieg;
                                break;
                            case Spielstatus.Weiter:
                                break;
                        }
                    }
                    break;
                default:
                    Console.WriteLine($"Fehler SplitAnzahl ist falsch");
                    break;
            }
            return (konto, earnedGeld, highscoreGeld, highscoreBlackJacks, gameOver, spielErgebnis, isWin, gameOver2, isStand2);
        }
        #endregion


        #endregion


        #region Anzeigen


        #region ZeigeSpielstand
        public void ZeigeSpielstand(int punkteSpieler, int punkteDealer, int rundenAnzahl, int zweiteHandPunkte, SplitAnzahl splitAnzahl)
        {
            //Methode zum Anzeigen des aktuellen Spielstandes nach jeder Runde
            switch (splitAnzahl)
            {
                case SplitAnzahl.ersterSplit:
                    Console.WriteLine("-------------------------------------------------");
                    Console.WriteLine($"Runde {rundenAnzahl} - Aktueller Stand:");
                    Console.WriteLine($"Du 1.Hand: {punkteSpieler} 2.Hand {zweiteHandPunkte} | Dealer: {punkteDealer}");
                    Console.WriteLine("-------------------------------------------------");
                    break;
                default:
                    Console.WriteLine("-------------------------------------------------");
                    Console.WriteLine($"Runde {rundenAnzahl} - Aktueller Stand:");
                    Console.WriteLine($"Du: {punkteSpieler} | Dealer: {punkteDealer}");
                    Console.WriteLine("-------------------------------------------------");
                    break;
            }

        }
        #endregion


        #region ZeigeEndstand
        public void ZeigeEndstand(int punkteSpieler, int punkteDealer, int rundenAnzahl, int zweiteHandPunkte, SplitAnzahl splitAnzahl, bool istTeilbar)
        {
            //Methode zum Anzeigen des Endstandes nach dem beenden nach dem Spiel
            if(istTeilbar && KannSplitten(punkteSpieler, zweiteHandPunkte))
            {
                Console.WriteLine("-------------------------------------------------");
                Console.WriteLine($"Endstand:");
                Console.WriteLine($"Du: {punkteSpieler}  2.Hand {zweiteHandPunkte} | Dealer: {punkteDealer}");
                Console.WriteLine($"Gespielte Runden: {rundenAnzahl}");
            }
            else
            {
                Console.WriteLine("-------------------------------------------------");
                Console.WriteLine($"Endstand:");
                Console.WriteLine($"Du: {punkteSpieler} | Dealer: {punkteDealer}");
                Console.WriteLine($"Gespielte Runden: {rundenAnzahl}");
            }
        }
        #endregion


        #region ZeigeEndergebnis
        public void ZeigeEndergebnisse(int konto, int wins, int loses, int highscoreGeld, int earnedGeld, int highscoreBlackJacks, int winstreak, int losestreak, int tiestreak, int ties)
        {
            //Methode zum anzeigen der Ergebnisse nach dem der Spieler aufhört weiterzuspielen
            if (konto <= 0)
            {
                Console.WriteLine($"Du hast dein ganzes Geld verzockt. Geh mal nach Hause lo!");
            }
            Console.WriteLine($"Winstreak: {winstreak}, Losestreak: {losestreak}, Tiestreak: {tiestreak}");
            Console.WriteLine($"Siege: {wins}, Niederlagen: {loses}, Unentschieden: {ties}");
            Console.WriteLine($"Höchster Betrag auf dem Konto: {highscoreGeld}€");
            Console.WriteLine($"Geld verdient: {earnedGeld}€");
            Console.WriteLine($"Anzahl an Blackjacks: {highscoreBlackJacks}");
            Console.ReadKey();
        }
        #endregion


        #endregion

    }
}

